<template>
    <div class="ml-2 mr-2">
        <b-modal :scrollable="true"  @hidden="reset" :hide-footer="true" size="lg"  ref="inputModal" id="my-modal" :title="title"  :centered="true">
            <form class="" method="POST"  @submit.prevent="onSubmit()"  @reset.prevent="reset()" @keydown=" updateFormErrors($event.target.name)" @change="updateFormErrors($event.target.name)">
                <div class="form-row">
                    <div class="form-group col-md-12">
                        <label class="">Nom <span class="star_label">(*)</span></label>
                        <input placeholder="Entrez le nom du projet"  class="form-control form-control-md form-custom-input-sm" name="titre" v-model="form.titre" type="text" />

                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('titre')" v-text="form.errors.get('titre')"></span>
                    </div>
                </div>

                <div class="form-row"> 
                    <div class="form-group col-md-6 isInvalid entreprise-input "> 
                        <label class="">Entreprise <span class="star_label">(*)</span></label>
                        <multi-select  :showNoOptions="justTosayNo" :showNoResult="searchingEntreprise" :loading="searchingEntreprise" :searchable="true"  :internal-search="false"
                        @input="trackEntreprise" name="entreprise_id" @search-change="asyncFindEntreprise" :multiple="false"
                        v-model="entreprise" :options="enterpriseAsParameter" :options-limit="100" :show-labels="false" 
                        open-direction="bottom" :close-on-select="true" label="nom_commercial" track-by="id">
                            <span slot="noResult" v-if="!searchingEntreprise">Aucune entreprise trouvée</span>
                            <span slot="noOptions">Cherchez une entreprise Prepa-Gabon</span>
                        </multi-select>
 
                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('entreprise_id')" v-text="form.errors.get('entreprise_id')"></span>
                    </div>

                    <div class="form-group col-md-6 isInvalid responsable-input "> 
                        <label class="">Responsable <span class="star_label">(*)</span></label>
                        <multi-select  @input="trackResponsable" :showNoOptions="justTosayNo" :showNoResult="searchingMember" :loading="searchingMember" :searchable="true"  :internal-search="false"
                        name="responsable_id" @search-change="asyncFind" :multiple="false"
                        v-model="responsable" :options-limit="100" :show-labels="false"
                        open-direction="bottom" :close-on-select="true" placeholder="Recherchez le responsable"
                        :options="memberAsParameter" label="fullName" track-by="id">
                            <span slot="noResult" v-if="!searchingMember">Aucun membre trouvé</span>
                            <span slot="noOptions">Cherchez un membre Prepa-Gabon</span>
                        </multi-select>

                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('responsable_id')" v-text="form.errors.get('responsable_id')"></span>
                    </div>

                </div>
                <div class="form-row">
                    <div class="form-group col-md-6">
                        <label class="">Date de debut <span class="star_label">*</span></label>
                        <input placeholder=""  class="form-control form-control-md form-custom-input-sm" name="date_debut_prev" v-model="form.date_debut_prev" type="date" />
                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_debut_prev')" v-text="form.errors.get('date_debut_prev')"></span>
                    </div>
                    <div class="form-group col-md-6">
                        <label class="">Date de fin <span class="star_label">*</span></label>
                        <input placeholder=""  class="form-control form-control-md form-custom-input-sm" name="date_fin_prev" v-model="form.date_fin_prev" type="date"/>
                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_fin_prev')" v-text="form.errors.get('date_fin_prev')"></span>
                    </div>
                </div>

                <div class="form-row">
                    <div class="form-group col-md-6">
                        <label class="">Budget <span class="star_label">*</span></label>
                        <div class="input-group mb-3">
                            <input placeholder=""  class="form-control form-control-md form-custom-input-sm" name="budget" v-model="form.budget" type="text" />
                            <div class="input-group-append">
                                    <span class="input-group-text" id="basic-addon1">F CFA</span>
                            </div>
                        </div>
                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('budget')" v-text="form.errors.get('budget')"></span>
                    </div>
                    <div class="form-group col-md-6">
                        <label class="">Avancement du projet<span class="star_label">*</span></label>
                        <div class="input-group mb-3">
                            <input placeholder=""  class="form-control form-control-md form-custom-input-sm" name="avancement" v-model="form.avancement" type="text" aria-describedby="basic-addon1"/>
                            <div class="input-group-append">
                                <span class="input-group-text" id="basic-addon1">%</span>
                            </div>
                        </div>
                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('avancement')" v-text="form.errors.get('avancement')"></span>
                    </div>
                </div> 

                <div class="form-row">
                    <div class="form-group col-md-12">
                        <label class="">Description <span class="star_label">(*)</span></label>
                        <textarea placeholder="Ajoutez un détails sur le projet"  class="form-control form-control-md form-custom-input-sm" name="description" v-model="form.description" type="text"></textarea>

                        <span class="m-form__help m--font-danger"  v-if="form.errors.has('description')" v-text="form.errors.get('description')"></span>
                    </div>   
                </div>

                <button  type="submit" class="mr-2 btn  btn-primary text-xs" :disabled="isLoading || form.errors.any()">
                    <i class="fas fa-check right "></i> {{ModalAction}}
                </button>
                    <br/><br/>
            </form>
        </b-modal>
    </div>
</template>

<script>
    import _  from 'lodash'

    import {FormWizard,WizardButton,WizardStep, TabContent} from 'vue-form-wizard'
    import 'vue-form-wizard/dist/vue-form-wizard.min.css'
   import Projets from "./Projets"
    import { mapGetters } from 'vuex'

    import Form from "./../../classes/Form"
    
    export default {
        
        data()
        {
            return{

                isLoading:false,
                justTosayNo:false,
                imageProfileIsLoading:false,
                imageGalleryIsLoading:false,
                FileIsLoading:false,
                filesAdded:[],
                modeEdit:false,
                modeles : [],
                entity:'',
                FileLimit:4,
                fileType:"",
                isMounted:false,
                oldImageUpdated:false,
                fileCounter:0,
                //VC-calendar
                mask:{

                    input: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                    data: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                },
                date_pmc:"",

                //multi-select
                marque:"",
                modele:"",
                motorisation:"",
                pays:"",
                permis:"",
                responsable:"",
                entreprise:"",
                tvehicule:"",
                secteur_activite:"",
                // entreprise_id:"",
                // responsable_id: "",
                avancement: "",

                //Options selectionnées
                plaisirs : [],
                conforts : [],
                securites : [],

                searchingMember: false,

                searchingEntreprise: false,

                opt:{
                    marques:[],
                    pays:[],
                    motorisations:[],
                    entreprise:[],
                    optConfort:[],
                    optPlaisir:[],
                    optSecurite:[],
                    secteurs:[],
                    tpermis:[],
                },

                form : new Form(
                    {
                        responsable_id:"",
                        titre:"",
                        description: "",
                        entreprise_id:"",
                        budget: "",
                        date_debut_prev: "",
                        date_fin_prev: "",
                        avancement: 0,
                    }
                  ),

            }
        },
        computed:
         {
           ...mapGetters({_enterprises:'params/_enterprises', enterpriseAsParameter:'enterprises/enterpriseAsParameter', projetAsParameter:'params/_projet', memberAsParameter:'members/memberAsParameter',_formations:'params/_formations',_competences:"params/_competences", items:"enterprises/_items"}),
           membres: function()
            {
               return []
            },
            projets: function()
            {
               return []
            },

            enterprises: function()
            {
               return []
            },

           setTitle: function()
            {
               return this.title +=" : Areddd"
            },
            title ()
            {
            return  this.modeEdit ? " Modification d'un projet"  : " Ajout d'un projet"
            },
            ModalAction ()
            {
            return  this.modeEdit ? " Modifier le projet"  : " Ajouter le projet"
            },
        },
        created()
        {
          // this.fetchOptions()
        },
        mounted()
         {

             //les options sont chargées
            this.isMounted = true;
            window.event.$on('new-projet-event',(e) => {
                this.modeEdit = false
                     this.initForm()
                     this.showModal()
            })
            window.event.$on('update-projet-event',(e) => {
                this.modeEdit = true
                  this.entity = e
                  this.initUpdate()
                  this.showModal()
            })
            
              this.$on('initOption', e => {
                this.initForm()
            })

        },
        methods:
        {
            
            onFileTypeMismatch (file) {
                alert('Type de fichier invalide. Please choose a jpeg or png file.')
            },
            onFileChosen (file)
            {
                this.fileType = file.type
            },

            // onRemoveLogo()
            // {
            //     //Si l'entreprise a un logo par défaut
            //     if(this.entity.hasLogo == true)
            //     {
            //         //alors le logo doit etre   actualisé
            //         this.form.logoMustBeUpdated = true
            //         console.log("Le logo a été actualisé")

            //     }
            //     else //Sinon
            //     {
            //         //Le logo reste vide
            //         this.form.logoMustBeUpdated = false
            //     }
            //     this.form.logo = ""
            // },
            onFileSizeExceed (file) {
                alert('File size exceeds. Please choose a file smaller than 100kb.')
            },
 
            datepickerEvent(event)
            {
                this.form.phone1 = moment(event).format('YYYY-MM-DD')
                this.updateFormErrors("phone1")
                //this.moreParams.filter_date_fin_prev = moment(periode.end).format('YYYY-MM-DD')
                //Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            asyncFind(query)
            {
                this.searchingMember = true
                this.executeSync(query,'members/memberAsParameter',"member")
            },

            asyncFindEntreprise(query)
            {
                
                console.log(query)
                this.searchingEntreprise = true
                this.executeSync(query,'enterprises/enterpriseAsParameter',"enterprise")
            },

            executeSync:_.debounce(function(query, url, type)
            {
                // if(query=="") return
                
                if(type=='enterprise')
                    
                  this.searchingEntreprise = true
                else
                  this.searchingMember = true

                this.$store.dispatch(url,query).then((response) =>  //this.$store.dispatch(enterprises/enterpriseAsParameter,query).then((response) =>
                { 
                  if(type=='enterprise'){
                   this.searchingEntreprise = false
                  }else
                   this.searchingMember = false
                })
            },600)
               
                  //this.$store.dispatch("members/asParameters",query);
            ,
             fetchOptions()
             {
            //    axios.get("/api/dispatcher/options/projets").then((response) =>
            //     {
            //           this.opt.pays = response.data.pays
            //           this.opt.secteurs = response.data.secteurs
            //           this.$emit('option-fetch-event',response.data.projets)

                

            //           //envoie un event pour signifier le chargement des options
            //           this.$emit('initOption');
            //           this.pageInit =true
            //     },
            //     (error) =>
            //     {
            //       this.isLoading = false
            //     });
             },

             format_date(value){
                if (value) {
                return moment(String(value)).format('DD/MM/YYYY');
                }
            },

             dateFormat : function (date) {
                return moment(date, 'YYYY-MM-DD').format('DD/MM/YYYY');
            },

             initForm()
            {
                //General
                this.form.responsable_id="",
                this.form.modele_id="",
                this.form.titre="",
                this.form.description= "",
                this.form.entreprise_id="",
                this.form.budget = 0,
                this.form.date_debut_prev = "",
                this.form.date_fin_prev= "",
                this.form.avancement=0
            },

            initUpdate()
            {
                //General
                
                this.form.id=this.entity.id,
                this.form.responsable_id=this.entity.responsable_id,
                this.form.modele_id="",
                this.form.titre=this.entity.titre,
                this.form.description= this.entity.description,
                this.form.entreprise_id=this.entity.entreprise_id,
                this.form.budget=this.entity.budget,
                this.form.date_debut_prev=this.entity.date_debut_prev,
                this.form.date_fin_prev=this.entity.date_fin_prev,
                this.form.avancement=this.entity.avancement
            },
            
            updateFormErrors(name)
            {
                if(this.form.errors.any()==true)
                {
                    //on retire l erreur
                    this.form.errors.clear(name)
                    //on verifie s il  n ya plus d erreurs
                    if(this.form.errors.any()==false)
                    {
                        this.$refs[this.form].validationError = null
                    }
                }

            },

          //ajout de la voiture par étape
          
          onSubmit()
           {
            //    console.log(this.form.errors.get('entreprise_id'))
                this.isLoading = true

                this.$store.dispatch(this.modeEdit ? "projets/updateProjet":"projets/addProjet",this.form).then((response) =>
                {
                    console.log(this.modeEdit)
                    flash(!this.modeEdit ?"<span>Enregistré <strong>avec succès</strong></span>" : "<span>Modifié <strong>avec succès</strong></span>",'success')
                    this.isLoading = false
                    this.$refs['inputModal'].hide() 
                },
                (error) => 
                     {
                      console.log(error)
                      this.isLoading = false
                      this.form.onFail(error.response.data)
                    });
           }, 

            updateStep(prevIndex, nextIndex)
            {
                if(!this.form.errors.any())
                {

                  this.form.step = nextIndex
                  this.$forceUpdate()
                }
            },

            setLoading(value)
            {
               this.isLoading = value
            },
            addSecuriteOpt(option)
            {
              console.log(option)
            },
            //Charge l'image
            readURL(event)
            {
                this.imageProfileIsLoading = true
                  var input = event.srcElement;
                  if (input.files && input.files[0]) {
                var reader = new FileReader();
                  var vm = this
                reader.onload = function (e)
                {
                    // $('.image-uploader-content img').attr('src', e.target.result);
                    // vm.form.logo = e.target.result;
                    // //console.log(e.target.result)
                    // vm.imageProfileIsLoading = false
                };
                reader.readAsDataURL(input.files[0]);
            }},
            //Charge l'image
            onUploadDocument(name,event)
            {

                  var input = event.srcElement;
                  if (input.files && input.files[0])
                   {
                    var reader = new FileReader();
                    var vm = this
                    reader.onload = function (e)
                    {

                            vm.form[name].fichier = e.target.result;
                            vm.form[name].nom_fichier=input.files[0].name
                            vm.form[name].hasFile=true

                    };
                    reader.readAsDataURL(input.files[0]);
                   }
            },
             //Retire l'image des
            removeImage(index)
            {
               this.form.images.splice(index,1)

            },
            //Charge les images de la galerie
            readURLGalerie(event)
            {
                  var input = event.srcElement;
                  this.imageGalleryIsLoading = true
                  if (input.files && input.files[0])
                  {

                      var index = 0
                      var vm = this
                      this.fileCounter = input.files.length
                      this.imageGalleryIsLoading = true
                      for(index;index<input.files.length;index++)
                      {
                        var reader = new FileReader();
                        reader.onload = function (e)
                        {
                            //$('.image-uploader-content img').attr('src', e.target.result);
                            //vm.form.logo = e.target.result;
                            vm.form.images.push(e.target.result)
                            vm.fileCounter--

                        };
                        reader.readAsDataURL(input.files[index]);
                      }
                   }
            },
             registerFile(event)
            {
              this.form.images.push(event.dataURL)
              this.FileIsLoading = false
            },
            removedfileFromDropzone(file, error, xhr)
            {
                var oldSize = this.form.images.length
                this.form.images= this.form.images.filter(e => { return e !==file.dataURL })
                if(this.form.images.length != oldSize)
                {
                    this.FileLimit++
                }

            },
            fileAdded(event)
            {
              var reader = new FileReader();
              var vm = this
              reader.onload = function (e)
              {
                    if(vm.FileLimit > 0)
                    {
                        vm.form.images.push(e.target.result)
                        vm.FileLimit--;
                    }
                    else
                    {
                        vm.$refs.dropzone.removeFile(event)
                    }
                   
            
              };
            
             reader.readAsDataURL(event);
             
       
              
            },
            maxFilesReached(file)
            {
              //console.log(file)
              //this.$refs.dropzone.removeFile(file)
            },
            onComplete()
            {

            },
            showModal()
             {
                this.$refs['inputModal'].show()

             },

            //  showModalOnEdit(entity)
            //  {
            //       this.modeEdit = true
            //       this.form.titre = entity.titre
            //       this.form.id=entity.id
            //       this.$refs['inputModal'].show()
            //  },

              reset()
             {
                  if(this.modeEdit)
                  {
                      log(this.$refs.cropper)
                  }
                  this.initForm()
                  this.form.errors.clearAll();
                   this.entity=""
             },

             // Events
             trackSecteurActivite(e)
             {
                             log(this.$refs.cropper)

                 if(e!=null)
                 {
                   this.form.secteur_activite_id = e.id

                 }
                 else
                 {

                 }
                 this.updateFormErrors("secteur_activite_id");


             },
              trackModele(e)
             {
                 if(e!=null)
                 {
                   this.form.modele_id = e.id
                 }
                 else
                 {
                   this.form.modele_id =""
                 }
             },

             trackResponsable(e)
             {
                 if(e!=null)
                 {
                     console.log(e);
                   this.form.responsable_id = e.id
                 }
                 else
                 {
                   this.form.responsable_id =""
                 }
             },
            trackEntreprise(e)
             {
                 if(e!=null)
                 {
                   this.form.entreprise_id = e.id
                 }
                 else
                 {
                   this.form.entreprise_id =""
                 }
             },
            trackTM(e)
             {
                 if(e!=null)
                 {
                   this.form.modele_id = e.id
                 }
                 else
                 {
                   this.form.modele_id =""
                 }
             },
              trackPays(e)
             {
                 if(e!=null)
                 {
                   this.form.pays_id = e.id
                 }
                 else
                 {
                    this.form.pays_id = ""
                 }
                 this.updateFormErrors("pays_id");
             },
             trackEffectif(e)
             {
                 if(e!=null)
                 {
                   this.form.pays_id = e.id
                 }
                 else
                 {
                    this.form.pays_id = ""
                 }
                 this.updateFormErrors("effectif");
             }
        },
        components:
         {
          FormWizard,
          TabContent,WizardButton,WizardStep,Projets,
         },
         watch:
         {
             "fileCounter":function(val)
             {
                 if(this.fileCounter==0 && this.imageGalleryIsLoading == true)
                 {
                     this.imageGalleryIsLoading = false
                 }
             },
            "OptionsIds":function(val)
             {
                 this.form.options = val
             },
             "form.responsable_id" : function(value)
             {
                 if(value!="")
                 {
                  this.updateFormErrors("responsable_id");
                 }

             }, 
            "form.entreprise_id" : function(value)
             {
                 if(value!="")
                 this.updateFormErrors("entreprise_id");
             },

             "form.avancement" : function(value)
             {
                 if(value < 0 && value>100)
                 this.updateFormErrors("avancement");
             },
         }

    }
</script>
<style lang="scss">
.wizard-header,.wizard-progress-with-circle {
    display:none !important;
}
.dataTables_info select {
    width: auto;
    display: inline-block;

        height: calc(1.5em + 1rem + 2px);
    padding-top: 0.5rem;
    padding-bottom: 0.5rem;
    padding-left: 1rem;
    font-size: 0.875rem;
    padding: 0.65rem 2rem 0.65rem 1rem;
    font-weight: 400;
    line-height: 1.5;
    color: #495057;
    vertical-align: middle;
    background: #fff url("data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='4' height='5' viewBox='0 0 4 5'%3e%3cpath fill='%23343a40' d='M2 0L0 2h4zm0 5L0 3h4z'/%3e%3c/svg%3e") no-repeat right 1rem center/8px 10px;
    border: 1px solid #e2e5ec;
    border-radius: 0.25rem;
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;

}
.vue-dropzone
{
    width: 100%;
    margin-top: 34px;
    min-height: 270px;
    position:relative;
    display: flex;
    -webkit-box-pack: center !important;
    justify-content: center !important;
    
}
.dz-message{
    width: 50%;
    margin: auto !important;
    position: absolute;
    top: 50%;
    left: 50%;
    -webkit-transform: translate(-50%,-50%);
    -ms-transform: translate(-50%,-50%);
    transform: translate(-50%,-50%);
}

.profile-image-preview {
    width: 300px !important;
}
.profile-image-preview img {
    width: inherit !important;
    height: inherit !important;
    -o-object-fit: contain !important;
    object-fit: contain !important;
}
.country .multiselect__option
{
    display: flex;
}
.country .multiselect__option img
{
    margin-right: 10px;
    color: rgba(0, 0, 0, 0) !important;

}
.recap h6
{
    font-weight: 600!important;
    margin-bottom: .75rem!important;
    font-size: 0.975rem;
}
.recap table tr td:first-child
{
    font-weight: 900;
}
.recap table tr td:last-child
{
   padding-left:10px;
   color:#80808f!important;
   line-height: 1.5;
     white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
    position: relative;
  display: inline-block;
      max-width: 160px;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
}
.responsable-input .multiselect__content .input li > span > span.remove-options
{
   display: none !important;
}

.entreprise-input .multiselect__content .input li > span > span.remove-options
{
   display: none !important;
}
.profile-image-previewx {
    width: 250px !important;
    height: 250px !important;
}
.profile-image-previewx  img{
width: inherit;

}
#my-modal___BV_modal_body_
{
  padding-top: 10px !important;
  padding-bottom: 0 !important;
}
.vue-form-wizard .wizard-tab-content {
    min-height: 100px;
    padding: 10px 20px 10px;
}

.modal-header .close{
    color: red;
}
</style>
